import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import rtl.*;

public class Tetris implements KeyListener {

  static Timer timer;
  static DrawingCanvas canvas;
  static JTextField textField;
  static int DELAY = 300;
  static int score=0;
  static int levelScore=0;
  static Player[] player = new Player[10];
  static int tid=0;
  static String navn;
  static TextFileWrite tfw;
  static TextFileRead tfr;

  static int sek=0;
  static int point=0;

  final static int D=15;
  final static int HEIGHT=420;
  final static int WIDTH=150;
  final static int xmin = 0;
  final static int xmax = WIDTH/D-1;
  final static int ymin = 0;
  final static int ymax = HEIGHT/D-1;

  static int[][] felt = new int[ymax+1][xmax+1] ;

  static int[] x1 = {0,0,1,2,3};
  static int[] y1 = {0,0,0,0,0};
  static Brik liv = new Brik(x1,y1,1);

  static int[] x2 = {0,0,1,0,1};
  static int[] y2 = {0,0,0,1,1};
  static Brik katrine = new Brik(x2,y2,2);

  static int[] x3 =  {0,0,0,0,1};
  static int[] y3 =  {0,0,1,2,1};
  static Brik randi = new Brik(x3,y3,3);

  static int[] x4 =  {0,0,0,1,1};
  static int[] y4 =  {0,1,2,0,1};
  static Brik britt = new Brik(x4,y4,4);

  static int[] x5 = {0,0,0,1,1};
  static int[] y5 = {0,0,1,1,2};
  static Brik kari = new Brik(x5,y5,5);

  static int[] x6= {0,0,0,0,1};
  static int[] y6 = {0,0,1,2,0};
  static Brik kjell = new Brik(x6,y6,6);

  static int[] x7 = {0,0,1,1,1};
  static int[] y7 = {0,0,0,1,2};
  static Brik hanne = new Brik(x7,y7,7);

  static Brik[] briks = {liv,katrine,randi,britt,kari,kjell,hanne};

  static Brik farveBrik,sortBrik;

  static int[] farve = {0,1,2,3,4,5,6,7};

  public Brik drej90(Brik brik) {
    int[] x90 = new int[5];
    int[] y90 = new int[5];

    x90[0] = brik.x[0];
    y90[0] = brik.y[0];

    for (int k=1; k<=4; k++) {
      x90[k] = -brik.y[k];
      y90[k] = brik.x[k];
    }
    Brik brik90 = new Brik(x90,y90,brik.farve);
    return brik90;
  }

  public void setScore() {
    score = score + point;
    textField.requestFocus();
    textField.setText("Score: "+score+"  Tid: "+sek+" sek");
    if (score>=levelScore+500) {
      levelScore=score;
      DELAY=Math.round((int)(DELAY*0.75));
      timer.setDelay(DELAY);
    }
  }


  public void keyPressed(KeyEvent keyEvent){
    switch (keyEvent.getKeyCode()) {
      case KeyEvent.VK_UP: {
        sortBrik = assignBrik(farveBrik);
        sortBrik = drej90(sortBrik);
        if (!kollisioner(sortBrik)) {
          tegnBrik(canvas, farveBrik, 0);
          tegnBrik(canvas, sortBrik, farveBrik.farve);
          farveBrik = assignBrik(sortBrik);
        }
        break;
      }
      case KeyEvent.VK_LEFT: {
              sortBrik = assignBrik(farveBrik);
              sortBrik.x[0] = sortBrik.x[0]-1;
              if (!kollisioner(sortBrik)) {
                tegnBrik(canvas, farveBrik, 0);
                tegnBrik(canvas, sortBrik, farveBrik.farve);
                farveBrik = assignBrik(sortBrik);
              }
              break;
      }
      case KeyEvent.VK_RIGHT: {
              sortBrik = assignBrik(farveBrik);
              sortBrik.x[0] = sortBrik.x[0]+1;
              if (!kollisioner(sortBrik)) {
                tegnBrik(this.canvas, this.farveBrik, 0);
                tegnBrik(this.canvas, this.sortBrik, this.farveBrik.farve);
                this.farveBrik = assignBrik(this.sortBrik);
              }
              break;
      }
      case KeyEvent.VK_DOWN: {
            Brik brik = new Brik();
            brik = assignBrik(farveBrik);
            do {
              sortBrik = assignBrik(brik);
              brik.y[0]--;
            }
            while(!ramtBund(brik));

            tegnBrik(canvas, farveBrik, 0);
            farveBrik = assignBrik(sortBrik);
            tegnBrik(canvas, farveBrik, farveBrik.farve);
            for (int k=1; k<=4; k++)  {
              int brikX = farveBrik.x[k]+farveBrik.x[0];
              int brikY = farveBrik.y[k]+farveBrik.y[0];
              felt[brikY][brikX] = farveBrik.farve;
            }
            farveBrik = nyBrik();
            point = raekkeFyldtOpCheck(canvas);
            if (point>0) setScore();
            tid++;
            sek = (int)(tid*(double)(DELAY)/1000.);
      }
    }
  }

  public void keyTyped(KeyEvent keyEvent) {
  }
  public void keyReleased(KeyEvent keyEvent){
  }

  public Brik assignBrik(Brik brik) {
    Brik assignbrik = new Brik();
    for (int k=0; k<=4; k++) {
      assignbrik.x[k] = brik.x[k];
      assignbrik.y[k] = brik.y[k];
    }
    assignbrik.farve = brik.farve;
    return assignbrik;
  }

  public void tegnFelt(DrawingCanvas canvas, int x0, int y0, int farve) {
    Image offScreenImage = canvas.getOffscreenImage();
    Graphics imageGraphics = offScreenImage.getGraphics();
    Graphics screen = canvas.getGraphics();

    switch (farve) {
      case 0: imageGraphics.setColor(Color.black); break;
      case 1: imageGraphics.setColor(Color.magenta); break;
      case 2: imageGraphics.setColor(Color.red); break;
      case 3: imageGraphics.setColor(Color.green); break;
      case 4: imageGraphics.setColor(Color.blue); break;
      case 5: imageGraphics.setColor(Color.gray); break;
      case 6: imageGraphics.setColor(Color.orange);  break;
      case 7: imageGraphics.setColor(Color.yellow);
    }
    imageGraphics.fillRect(x0*D,HEIGHT-y0*D,D,D);
    canvas.paint(screen);
  }

  public void tegnBrik(DrawingCanvas canvas, Brik brik, int farve) {
      for (int k=1; k<=4; k++) {
        int brikX = brik.x[0]+brik.x[k];
        int brikY = brik.y[0]+brik.y[k];
        tegnFelt(canvas,brikX,brikY,farve);
      }
  }

  public Brik nyBrik() {
    Brik brik = new Brik();
    brik = assignBrik(briks[(int)(Math.random()*7)]);
    brik.x[0] = (int)(Math.random()*5+2);
    brik.y[0] = ymax-2;
    return brik;
  }

  public boolean kollisioner(Brik brik) {
    boolean kollision=false;
    int k=1;
    while ((!kollision)&&(k<=4)) {
      int brikX = brik.x[k]+brik.x[0];
      int brikY = brik.y[k]+brik.y[0];
      if (brikY<=ymax) {
        kollision = (brikX < xmin)||(brikX > xmax);
        if (!kollision) kollision=(felt[brikY][brikX]!=0);
      }
      k++;
    }
    return kollision;
  }

  public boolean ramtBund(Brik brik) {
    boolean ramt=false;
    int k=1;
      while ((!ramt)&&(k<=4)) {
        int brikX = brik.x[k]+brik.x[0];
        int brikY = brik.y[k]+brik.y[0];
        if (brikY<=ymax) {
          ramt = (brikY<0);
          if (!ramt) ramt = felt[brikY][brikX]!=0;
        }
        k++;
      }
    return ramt;
  }

  public boolean raekkeTom(int[] raekke) {
    boolean tom=true;
    int k=0;
    while (tom && (k<=xmax)) {
      tom = raekke[k]==0; k++;
    }
    return tom;
  }

  public int raekkeFyldtOpCheck(DrawingCanvas canvas) {
    boolean tomRaekke,fyldtRaekke;
    int point=0;
    int x=0, y=0;
    do  {
      fyldtRaekke=true;
      tomRaekke=false;
      x=0;
      while (fyldtRaekke && (x<=xmax)) {
        fyldtRaekke = (felt[y][x]!=0);
        x++;
      }
      if (fyldtRaekke) {
        point+=100;
        int y0=y;
        do {
          for(x=0; x<=xmax; x++) {
            felt[y0][x] = felt[y0+1][x];
            tegnFelt(canvas,x,y0,felt[y0][x]);
          }
          y0++;
        }
        while (!raekkeTom(felt[y0]));
        y--;
      }
      else {
        x=0;
        tomRaekke=true;
        while (tomRaekke && (x<=xmax)) {
          tomRaekke = (felt[y][x]==0);
          x++;
        }
      }
      y++;
    }
    while (!tomRaekke && (y<=ymax));
    return point;
  }

  public boolean naesteSkridt(DrawingCanvas canvas) {
    boolean kontakt=false;
    sortBrik = assignBrik(farveBrik);
    sortBrik.y[0]--;
    if (!ramtBund(sortBrik)) {
      tegnBrik(canvas, farveBrik, 0);
      farveBrik = assignBrik(sortBrik);
      tegnBrik(canvas, farveBrik, farveBrik.farve);
    }
    else {
      for (int k=1; k<=4; k++) {
        int brikX = farveBrik.x[k]+farveBrik.x[0];
        int brikY = farveBrik.y[k]+farveBrik.y[0];
        felt[brikY][brikX] = farveBrik.farve;
      }
      kontakt = true;
      farveBrik = nyBrik();
    }
    if (!raekkeTom(felt[ymax])) {
      timer.stop();
      scoringsliste(this);
    }
    return kontakt;
  }

  public static Player[] rankSort(Player[] players, int n) {
    for (int i=0; i<n; i++) {
      int max=players[i].score, imax=i;
      for (int j=i+1;j<=n;j++) {
        if (players[j].score>max) {
          imax=j; max=players[j].score;
        }
        Player player=players[imax];
        players[imax]=players[i];
        players[i]=player;
      }
    }
    return players;
  }

  public void scoringsliste(Tetris tetris) {
    int nr=-1;
    String line;
    tfr = new TextFileRead("HallOfFame.txt");
    try {
      do {
        line=tfr.readLine();
        if (!tfr.eof()) {
          nr++;
          player[nr] = new Player();
          player[nr].name=line;
          line=tfr.readLine();
          player[nr].score=Integer.parseInt(line.trim());
        }
      }
      while (!tfr.eof());
      tfr.close();
    }
    catch (NullPointerException e) {
      System.out.println(e);
    }
    if (score>1000) {
      Dialogs.showMessage("Hello "+navn+": Det var flot. Du scorede "+score+" point");
    }
    else {
      Dialogs.showMessage("Hello "+navn+": Det var svagt. Du scorede kun "+score+" point");
    }
    if (score>player[0].score) {
      Dialogs.showMessage("Du slog den hidtige Topscorer: "+player[0].name+
                          ": Som scorede "+player[0].score+" point");
    }
    else {
      Dialogs.showMessage("Du slog ikke den hidtige Topscorer: "+player[0].name+
                          ": Som scorede "+player[0].score+" point");
    }
    if (nr<9) {
      nr++;
      player[nr] = new Player();
    }
    player[nr].name=navn;
    player[nr].score=score;
    Player[] players = new Player[10];
    players=rankSort(player,nr);

    String best="Hall of Fame \n"; int na;
    if (nr<5) na=nr+1; else na=5;
    for (int j=1;j<na;j++) {
      best=best+j+". "+players[j-1].name+": "+players[j-1].score+"\n";
    }
    best=best+na+". "+players[na-1].name+": "+players[na-1].score;
    Dialogs.showMessage(best);
    try {
      tfw = new TextFileWrite("HallOfFame.txt");
      for (int j=0;j<=nr;j++) {
        tfw.writeLine(players[j].name);
        tfw.writeLine(""+players[j].score);
      }
      tfw.close();
    }
    catch (NullPointerException e) {
      System.out.println(e);
    }

  }

  public static void main(String[] args) {

    Tetris tetris = new Tetris();
    JFrame frame = new JFrame();
    Container pane = frame.getContentPane();
    canvas = new DrawingCanvas(tetris.WIDTH,tetris.HEIGHT+D);
    pane.add(canvas);
    Image offScreenImage = canvas.getOffscreenImage();
    textField = new JTextField("Tid: 0  Score: 0");
    pane.add(textField, BorderLayout.SOUTH);
    textField.addKeyListener(tetris);
    textField.requestFocus();

    frame.pack();
    frame.show();

    for (int y=0; y<=tetris.ymax; y++) {
      for (int x=0; x<=tetris.xmax; x++) {
        tetris.felt[y][x]=0;
        tetris.tegnFelt(canvas,x,y,tetris.felt[y][x]);
      }
    }
    timer = new Timer(tetris.DELAY, new TimerListener(canvas,tetris, textField));

    tetris.farveBrik = tetris.nyBrik();
    tetris.sortBrik = new Brik();
    tetris.naesteSkridt(canvas);
    textField.setText("Tid: 0  Score: 0");
    tetris.navn=Dialogs.inputDialog("Hall of Fame", "Skriv dit navn eller Alias");
    tetris.timer.start();
  }
}

class Brik {
  int[] x = new int[5];
  int[] y = new int[5];
  int farve;
  Brik() {}
  Brik(int[] x, int[] y, int farve) {
    this.x = x; this.y = y; this.farve = farve;
  }
}

class DrawingCanvas extends JComponent {
  int width,height;

  DrawingCanvas(int width, int height) {
    this.width = width;
    this.height = height;
  }

  private Image offscreenImage;

  public void paint(Graphics screen) {
    if (offscreenImage!=null) screen.drawImage(offscreenImage,0,0,width,height,null);
  }

  public Image getOffscreenImage() {
    if (offscreenImage==null) offscreenImage = createImage(width,height);
    return offscreenImage;
  }

  public Dimension getMinimumSize() {
    return new Dimension(width,height);
  }

  public Dimension getPreferredSize() {
      return new Dimension(width,height);
  }
}

class TimerListener implements ActionListener {
  DrawingCanvas canvas;
  Tetris tetris;
  JTextField textField;

  TimerListener(DrawingCanvas canvas, Tetris tetris, JTextField textField) {
    this.canvas = canvas;
    this.tetris = tetris;
    this.textField = textField;
  }
  public void actionPerformed(ActionEvent actionEvent) {
    if (tetris.sek<600) {
      if (tetris.naesteSkridt(canvas)) {
        tetris.point = tetris.raekkeFyldtOpCheck(canvas);
        if (tetris.point>0) tetris.setScore();
      }
    }
    else {
      textField.requestFocus();
      textField.setText("Tid: "+tetris.sek+"  Score: "+tetris.score);
      tetris.timer.stop();
      tetris.scoringsliste(tetris);
    }
    tetris.tid++;
    tetris.sek = (int)(tetris.tid*(double)(tetris.DELAY)/1000.);
  }
}









