import java.awt.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import java.awt.event.*;

public class Bibliotek {

  public static JTextField isbnTextField;
  public static JTextField laanerIdTextField;
  public static JTextField datoTextField;
  public static JTextField dageTextField;
  public static JTextField forfatterTextField;
  public static JTextField titelTextField;
  public static JTextField annotationTextField;
  public static JTextField adresseTextField;
  public static JTextField navnTextField;
  public static JTextField tlfTextField;
  public static JTextField bogSqlTextField;
  public static JTextField laanerSqlTextField;

//  Constructor

  public Bibliotek() {

// Erklringer af Frame, Container og Menu Listeners

    JFrame menuFrame = new JFrame("Bibliotek Udln");
    Container pane = menuFrame.getContentPane();
    menuFrame.setSize(400,300);

    DatabaseMenuListener databaseMenuListener = new DatabaseMenuListener();
    FindMenuListener findMenuListener = new FindMenuListener();
    UdlaanMenuListener udlaanMenuListener = new UdlaanMenuListener();
    RapportMenuListener rapportMenuListener = new RapportMenuListener();
    HjaelpMenuListener hjaelpMenuListener = new HjaelpMenuListener();
    UdlaanNavigatorButtonListener udlaanNavigatorButtonListener =
                                  new UdlaanNavigatorButtonListener();

    JMenuBar menuBar = new JMenuBar();

  // Tilfjelse af menupunkter i hovedmenuen

    JMenu databaseMenu = new JMenu("Database");
    databaseMenu.setMnemonic('D');

    JMenu udlaanMenu = new JMenu("Udlaan");
    udlaanMenu.setMnemonic('U');

    JMenu findMenu = new JMenu("Find");
    findMenu.setMnemonic('F');

    JMenu rapportMenu = new JMenu("Rapporter");
    rapportMenu.setMnemonic('R');

    JMenu hjaelpMenu = new JMenu("Hjlp");
    hjaelpMenu.setMnemonic('H');

    menuBar.add(databaseMenu);
    menuBar.add(udlaanMenu);
    menuBar.add(findMenu);
    menuBar.add(rapportMenu);
    menuBar.add(hjaelpMenu);

  // Tilfjelse af menupunkter i de enkelte Menuer

    JMenuItem aabnMenuItem = new JMenuItem("bn Bibliotek",'');
    databaseMenu.add(aabnMenuItem);
    aabnMenuItem.addActionListener(databaseMenuListener);

    JMenuItem udlaanMenuItem = new JMenuItem("Udln",'U');
    databaseMenu.add(udlaanMenuItem);
    udlaanMenuItem.addActionListener(databaseMenuListener);

    JMenuItem boegerMenuItem = new JMenuItem("Bger",'B');
    databaseMenu.add(boegerMenuItem);
    boegerMenuItem.addActionListener(databaseMenuListener);

    JMenuItem laanereMenuItem = new JMenuItem("Lnere",'L');
    databaseMenu.add(laanereMenuItem);
    laanereMenuItem.addActionListener(databaseMenuListener);

    JMenuItem lukMenuItem = new JMenuItem("Luk Bibliotek",'u');
    databaseMenu.add(lukMenuItem);
    lukMenuItem.addActionListener(databaseMenuListener);

    JMenuItem udlaanBogMenuItem = new JMenuItem("Udln bog",'U');
    udlaanMenu.add(udlaanBogMenuItem);
    udlaanBogMenuItem.addActionListener(udlaanMenuListener);

    JMenuItem returnerBogMenuItem = new JMenuItem("Returner bog",'R');
    udlaanMenu.add(returnerBogMenuItem);
    returnerBogMenuItem.addActionListener(udlaanMenuListener);

    JMenuItem rydSoegeFelterMenuItem = new JMenuItem("Ryd Sgefelter",'R');
    findMenu.add(rydSoegeFelterMenuItem);
    rydSoegeFelterMenuItem.addActionListener(findMenuListener);


    JMenuItem laanerMenuItem = new JMenuItem("Find Lner",'L');
    findMenu.add(laanerMenuItem);
    laanerMenuItem.addActionListener(findMenuListener);

    JMenuItem bogMenuItem = new JMenuItem("Find Bog",'B');
    findMenu.add(bogMenuItem);
    bogMenuItem.addActionListener(findMenuListener);

    JMenuItem laanerOgBogMenuItem = new JMenuItem("Find Lner og Bog fra Udln",'o');
    findMenu.add(laanerOgBogMenuItem);
    laanerOgBogMenuItem.addActionListener(findMenuListener);

    JMenuItem boglisteMenuItem = new JMenuItem("Bogliste",'B');
    rapportMenu.add(boglisteMenuItem);
    boglisteMenuItem.addActionListener(rapportMenuListener);

    JMenuItem laanereAfBogMenuItem = new JMenuItem("Lnere af Bog",'L');
    rapportMenu.add(laanereAfBogMenuItem);
    laanereAfBogMenuItem.addActionListener(rapportMenuListener);

    JMenuItem BoegerSomLaanerHarMenuItem = new JMenuItem("Bger som lner har",'h');
    rapportMenu.add(BoegerSomLaanerHarMenuItem);
    BoegerSomLaanerHarMenuItem.addActionListener(rapportMenuListener);

    JMenuItem BoegerSomSkalHjemkaldesMenuItem = new JMenuItem("Bger som skal hjemkaldes",'k');
    rapportMenu.add(BoegerSomSkalHjemkaldesMenuItem);
    BoegerSomSkalHjemkaldesMenuItem.addActionListener(rapportMenuListener);

    menuFrame.setJMenuBar(menuBar);

    JPanel navigatorPanel = new JPanel(new FlowLayout());

    JButton firstButton = new JButton("<<");
    navigatorPanel.add(firstButton);

    JButton priorButton = new JButton("<");
    navigatorPanel.add(priorButton);

    JButton nextButton = new JButton(">");
    navigatorPanel.add(nextButton);

    JButton lastButton = new JButton(">>");
    navigatorPanel.add(lastButton);

    Border navigatorPanelBorder = BorderFactory.createBevelBorder(BevelBorder.RAISED);
    navigatorPanel.setBorder(navigatorPanelBorder);

    menuFrame.getContentPane().add(navigatorPanel,BorderLayout.NORTH);

    firstButton.addActionListener(udlaanNavigatorButtonListener);
    nextButton.addActionListener(udlaanNavigatorButtonListener);
    priorButton.addActionListener(udlaanNavigatorButtonListener);
    lastButton.addActionListener(udlaanNavigatorButtonListener);

    JPanel udlaanPanel = new JPanel(new GridLayout(4,2));

    JLabel isbnLabel = new JLabel("ISBN");
    JLabel laanerIdLabel = new JLabel("LAANER_ID");
    JLabel datoLabel = new JLabel("DATO");
    JLabel dageLabel = new JLabel("DAGE");

    isbnTextField = new JTextField(12);
    laanerIdTextField = new JTextField(12);
    datoTextField = new JTextField(10);
    dageTextField = new JTextField(5);

    udlaanPanel.add(isbnLabel);
    udlaanPanel.add(laanerIdLabel);
    udlaanPanel.add(isbnTextField);
    udlaanPanel.add(laanerIdTextField);
    udlaanPanel.add(datoLabel);
    udlaanPanel.add(dageLabel);
    udlaanPanel.add(datoTextField);
    udlaanPanel.add(dageTextField);

    Border udlaanPanelBorder = BorderFactory.createBevelBorder(BevelBorder.RAISED);
    udlaanPanel.setBorder(udlaanPanelBorder);

    menuFrame.getContentPane().add(udlaanPanel,BorderLayout.CENTER);

    JPanel soegningPanel = new JPanel(new GridLayout(9,2));

    JLabel bogLabel = new JLabel("Sgning efter Bog");
    JLabel forfatterLabel = new JLabel("Forfatter");
    JLabel titelLabel = new JLabel("Titel");
    JLabel annotationLabel = new JLabel("Sgeord i annotation");
    JLabel laanerLabel = new JLabel("Sgning efter Lner");
    JLabel navnLabel = new JLabel("Navn");
    JLabel adresseLabel = new JLabel("Adresse");
    JLabel tlfLabel = new JLabel("Tlf");
    JLabel bogSqlLabel = new JLabel("Select * From BOG Where 'betingelse'");
    JLabel laanerSqlLabel = new JLabel("Select * From LAANER Where 'betingelse'");


    forfatterTextField = new JTextField(20);
    titelTextField = new JTextField(20);
    annotationTextField = new JTextField(20);
    adresseTextField = new JTextField(20);
    navnTextField = new JTextField(20);
    tlfTextField = new JTextField(20);
    bogSqlTextField = new JTextField(20);
    laanerSqlTextField = new JTextField(20);


    soegningPanel.add(bogLabel);
    soegningPanel.add(laanerLabel);

    soegningPanel.add(titelLabel);
    soegningPanel.add(navnLabel);
    soegningPanel.add(titelTextField);
    soegningPanel.add(navnTextField);

    soegningPanel.add(forfatterLabel);
    soegningPanel.add(adresseLabel);
    soegningPanel.add(forfatterTextField);
    soegningPanel.add(adresseTextField);

    soegningPanel.add(annotationLabel);
    soegningPanel.add(tlfLabel);
    soegningPanel.add(annotationTextField);
    soegningPanel.add(tlfTextField);


    soegningPanel.add(bogSqlLabel);
    soegningPanel.add(laanerSqlLabel);
    soegningPanel.add(bogSqlTextField);
    soegningPanel.add(laanerSqlTextField);

    Border soegningPanelBorder = BorderFactory.createBevelBorder(BevelBorder.RAISED);
    soegningPanel.setBorder(soegningPanelBorder);

    menuFrame.getContentPane().add(soegningPanel,BorderLayout.SOUTH);

    menuFrame.pack();
    menuFrame.show();

  }

  public static void main(String[] args) {

    Bibliotek bibliotek = new Bibliotek();
    Boeger boeger = new Boeger();
    Laanere laanere = new Laanere();

  }
}

