import java.rmi.*;
import java.rmi.server.*;
import java.net.*;
import java.rmi.registry.*;
import java.security.*;
import java.util.*;

public class BankServer {

  public static void main(String[] args) {
    try {
      System.out.println("Constructing Server implementations");
      Registry registry = LocateRegistry.createRegistry(1099);
      System.setSecurityManager(new RMISecurityManager() {
        public void checkConnect(String host, int port) {
        }
        public void checkPermission(Permission p) {
        }
      });

      new SocketPermission("localhost:1024-", "accept,connect,listen,resolve");

      BankServerImpl bank = new BankServerImpl("RMI-Banken");

      System.out.println("Binding Server implementation to Rmi registry");

      registry.rebind("bank",bank);

      System.out.println("Venter p opkald fra klienter.....");

    }
    catch(Exception e) {
      System.out.println("BankServer: "+e);
    }
  }
}
