import rtl.*;
import java.util.*;
import java.rmi.*;
import java.rmi.server.*;

public class BankImpl extends UnicastRemoteObject implements BankInterface {

  static String bankNavn,ekspedition,navn,kontoNr;
  static Vector konti, ekspeditioner;
  static int saldo;
  Date dato;

  public BankImpl(String bankNavn, Vector konti, Vector ekspeditioner) throws RemoteException {
   this.bankNavn=bankNavn;
   this.konti=konti;
   this.ekspeditioner=ekspeditioner;
  }

  public synchronized String opretKonto(String navn, int saldo) throws RemoteException {

    String kontoNr;
    int kto;
    kontoNr=visKontoNr(navn);
    if (kontoNr.equals("0")) {
      kto = (int) Math.round(Math.random()*100000000);
      kontoNr = ""+kto;
      dato = new Date();
      konti.addElement(new Konto(navn,kontoNr,saldo));
      String ekspedition = bankNavn+": "+dato.toString()+"  er oprettet en konto "+
      "p navnet:"+navn+" og kto:"+kontoNr+". Saldo kr. "+saldo;
      ekspeditioner.addElement(ekspedition);
      BankServer.opdaterEkspeditioner(ekspeditioner);
      BankServer.opdaterKonti(konti);
    }
    return kontoNr;
  }

  public synchronized String nedlaegKonto(String kontoNr) throws RemoteException {

    for (int k=0; k<konti.size(); k++) {
      if (kontoNr.equals(((Konto)konti.get(k)).kontoNr)) {
        konti.remove(k);
        dato = new Date();
        String ekspedition =bankNavn+": "+dato.toString()+"  Kontoen "+kontoNr+" er nedlagt";
        ekspeditioner.addElement(ekspedition);
        BankServer.opdaterEkspeditioner(ekspeditioner);
        BankServer.opdaterKonti(konti);
        return ekspedition;
      }
    }
    return "Konto Nr "+kontoNr+" findes ikke";
  }



  public synchronized String visSaldo(String kontoNr) throws RemoteException {
    for (int k=0; k<konti.size(); k++) {
      if (kontoNr.equals(((Konto)konti.get(k)).kontoNr))
        return "Saldoen p kontoen "+kontoNr+" er "+((Konto)konti.get(k)).saldo;
    }
    return "Konto Nr "+kontoNr+" findes ikke";
  }

  public synchronized String visKontoNr(String navn) {
    for (int k=0; k<konti.size(); k++) {
      if (navn.equals(((Konto)konti.get(k)).navn))
        return ((Konto)konti.get(k)).kontoNr;
    }
    return "0";
  }

  public synchronized boolean indsaetBeloeb(String kontoNr, int beloeb) throws RemoteException {

    for (int k=0; k<konti.size(); k++) {
      if (kontoNr.equals(((Konto)konti.get(k)).kontoNr)) {
        int saldo = ((Konto)konti.get(k)).saldo+beloeb;
        ((Konto)konti.get(k)).saldo = saldo;
        dato = new Date();
        String ekspedition = bankNavn+": "+dato.toString()+" indsat "+beloeb+
                             " kr. p konto:"+kontoNr+". Saldo kr. "+saldo;
        ekspeditioner.addElement(ekspedition);
        BankServer.opdaterEkspeditioner(ekspeditioner);
        BankServer.opdaterKonti(konti);
        return true;
      }
    }
    return false;
  }

  public synchronized boolean haevBeloeb(String kontoNr, int beloeb) throws RemoteException {

    for (int k=0; k<konti.size(); k++) {
      if (kontoNr.equals(((Konto)konti.get(k)).kontoNr)) {
        if ((beloeb>0) && (((Konto)konti.get(k)).saldo>=beloeb)) {
          int saldo = ((Konto)konti.get(k)).saldo-beloeb;
          ((Konto)konti.get(k)).saldo = saldo;
          dato = new Date();
          String ekspedition = bankNavn+": "+dato.toString()+"  hvet "+beloeb+
                               " kr. p konto:"+kontoNr+". Saldo kr. "+saldo;
          ekspeditioner.addElement(ekspedition);
          BankServer.opdaterEkspeditioner(ekspeditioner);
          BankServer.opdaterKonti(konti);
          return true;
        }
        else return false;
      }
    }
    return false;
  }

  public synchronized Vector visEkspeditioner(String kontoNr) throws RemoteException {

    Vector ktoExpd = new Vector();
    for (int k=0; k<ekspeditioner.size(); k++) {
      String exp =(String)ekspeditioner.get(k);
      if (exp.indexOf(kontoNr)>0) ktoExpd.addElement(exp);
    }
    return ktoExpd;
  }
}


