import java.io.*;
import java.rmi.*;
import java.rmi.server.*;
import rtl.*;
import java.util.*;

public class BankServer {

  final static String KONTI_LOG = "konti.txt";
  final static String EXPD_LOG = "expd_log.txt";
  static Vector konti,ekspeditioner;
  static BankImpl bank;
  final static String bankNavn="Rmi-Banken";

  public static void laesFiler() {
    int saldo;
    String bank,ekspedition,navn,kontoNr;
    konti = new Vector();
    ekspeditioner = new Vector();

    try {
      TextFileRead expd_log = new TextFileRead(EXPD_LOG);
      do {
        ekspedition=expd_log.readLine();
        if (!expd_log.eof()) {
          ekspeditioner.addElement(ekspedition);
        }
      }
      while (!expd_log.eof());
      expd_log.close();
    }
   catch (NullPointerException e) {
     System.out.println("BankServer TextFileRead expd_log: "+e);
   }
   try {
     TextFileRead konti_log = new TextFileRead(KONTI_LOG);
     do {
       navn = konti_log.readLine();
       if (!konti_log.eof()) {
         kontoNr = konti_log.readLine();
         saldo = Integer.parseInt(konti_log.readLine());
         Konto konto = new Konto(navn, kontoNr, saldo);
         konti.addElement(konto);
       }
     }
     while (!konti_log.eof());
     konti_log.close();
   }
   catch (NullPointerException e) {
     System.out.println("BankServer TextFileRead konti: "+e);
   }
 }

  public static void skrivFiler() {

    try {
      TextFileWrite expd_log = new TextFileWrite(EXPD_LOG);
      for (int j=0;j<ekspeditioner.size();j++) {
        expd_log.writeLine((String)ekspeditioner.get(j));
      }
      expd_log.close();
    }
    catch (NullPointerException e) {
      System.out.println(e);
    }

    try {
      TextFileWrite konti_log = new TextFileWrite(KONTI_LOG);
      for (int j=0;j<konti.size();j++) {
        konti_log.writeLine(((Konto)konti.get(j)).navn);
        konti_log.writeLine(((Konto)konti.get(j)).kontoNr);
        konti_log.writeLine(""+((Konto)konti.get(j)).saldo);
      }
      konti_log.close();
    }
    catch (NullPointerException e) {
      System.out.println(e);
    }
  }

  public static void opdaterEkspeditioner(Vector ekspeditioner) {
    BankServer.ekspeditioner=ekspeditioner;
  }

  public static void opdaterKonti(Vector konti) {
    BankServer.konti=konti;
  }

  public static void main(String[] args) {
    KbdRead kbd = new KbdRead();
    char valg;
    String navn;
    try {
      System.out.println("Indlser konti og posterings log fra filer");
      laesFiler();
      System.out.println("BankServer: Constructing Server implementations");
      bank = new BankImpl(bankNavn, konti, ekspeditioner);
      System.out.println("Binding Server implementation to Rmi registry");
      Naming.rebind("bank",bank);
      System.out.println("Venter p henvendelser fra Kunder");
      System.out.println("");
      do {
        System.out.println("*** "+bankNavn+"***");
        System.out.println("");
        System.out.println("1. Indls kontoSystem");
        System.out.println("2. Vis alle kontohavere");
        System.out.println("3. Vis alle posteringer");
        System.out.println("4. Vis konto nummer");
        System.out.println("5. Gem Kontosystem");
        System.out.println("6. Luk Banken");
        System.out.print("Valg: "); valg=kbd.readChar();
        switch(valg) {
          case '1':
            laesFiler(); break;
          case '2':
            System.out.println("Kontoindehavere i Banken");
            System.out.println();
            for (int j=0;j<konti.size();j++) {
              System.out.println(((Konto)konti.get(j)).navn);
              System.out.println(((Konto)konti.get(j)).kontoNr);
              System.out.println(""+((Konto)konti.get(j)).saldo);
              System.out.println();
            }
            break;
          case '3':
            System.out.println("Posteringer i Banken");
            System.out.println();
            for (int k=0; k<ekspeditioner.size(); k++) {
              System.out.println((String)ekspeditioner.get(k));
              System.out.println();
            }
            break;
          case '4':
            System.out.print("Indls navn"); navn=kbd.readString();
            for (int k=0; k<konti.size(); k++) {
              if (navn.equals(((Konto)konti.get(k)).navn)) {
                System.out.println(navn+"s Kontonummeret er "+((Konto)konti.get(k)).kontoNr);
                break;
              }
            }
            System.out.println("Ingen kontohavere med navnet "+navn);
            break;
          case '5':
            skrivFiler(); break;
          case '6':
            System.exit(0);
          }
          System.out.println();
          System.out.println();
        }
        while (valg!='6');
    }
    catch(Exception e) {
      System.out.println("BankServer "+e);
    }
  }
}
