import java.rmi.*;
import java.rmi.server.*;
import rtl.*;
import java.util.*;


public class Kunde {
  static BankInterface bank;
  static VarehusInterface varehus;

  public static void main(String[] args) {
    KbdRead kbd = new KbdRead();
    char valg;
    String navn,kontoNr,vareId;
    int saldo, beloeb;

    try {
      System.setSecurityManager(new RMISecurityManager());
      bank = (BankInterface)Naming.lookup("rmi://localhost/bank");
      varehus = (VarehusInterface)Naming.lookup("rmi://localhost/varehus");

      System.out.println("Linie til Bank og Varehus er oprettet");

      do {
        System.out.println("1. Opret Konto i Bank");
        System.out.println("2. Indst p konto i Bank");
        System.out.println("3. Hv fra konto i Bank");
        System.out.println("4. Vis Saldo i Bank");
        System.out.println("5. Vis posteringer p konto i bank");
        System.out.println("6. Nelg konto");
        System.out.println("7. Vis Varesortiment fra Varehus ");
        System.out.println("8. Kb vare i Varehus");
        System.out.println("8. Vis kvitteringer fra Varehus");
        System.out.println("0. Afslut ");
        System.out.println();
        System.out.print("Valg: "); valg=kbd.readChar();
        switch(valg) {

          case '1':
            System.out.print("Navn: "); navn=kbd.readString();
            System.out.print("Saldo: "); saldo=kbd.readInteger();
            System.out.println(bank.opretKonto(navn,saldo));
            break;

          case '2':
            System.out.print("KontoNr: "); kontoNr=kbd.readString();
            System.out.print("belb: "); beloeb=kbd.readInteger();
            if (bank.indsaetBeloeb(kontoNr, beloeb))
              System.out.println("Belbet "+beloeb+" kr. er indsat p kontoNr "+kontoNr);
            else
              System.out.println("Belbet kunne ikke indsttes p kontoNr: "+kontoNr);
            break;

          case '3':
            System.out.print("KontoNr: "); kontoNr=kbd.readString();
            System.out.print("belb: "); beloeb=kbd.readInteger();
            if (bank.haevBeloeb(kontoNr, beloeb))
              System.out.println("Belbet "+beloeb+" kr. er hvet p konto: "+kontoNr);
            else
              System.out.println("Belbet kunne ikke hves p konto: "+kontoNr);
            break;

          case '4':
            System.out.print("KontoNr: "); kontoNr=kbd.readString();
            System.out.println(bank.visSaldo(kontoNr));
            break;

          case '5':
            System.out.print("KontoNr: "); kontoNr=kbd.readString();
            Vector posteringer = bank.visEkspeditioner(kontoNr);
            if (posteringer.size()>0) {
              for (int j=0; j<posteringer.size(); j++) {
                String postering = (String)posteringer.get(j);
                System.out.println(postering);
              }
            }
            else
              System.out.println("Ingen posteringer p konto: "+kontoNr);
              break;
          case '6':
              System.out.print("KontoNr: "); kontoNr=kbd.readString();
              System.out.println(bank.nedlaegKonto(kontoNr));
              break;
          case '7':
            Vector varesortiment = varehus.visVarer();
            if (varesortiment.size()>0) {
              for (int j=0; j<varesortiment.size(); j++) {
                Vare vare = (Vare)varesortiment.get(j);
                System.out.println("Vare ID: "+vare.vareId);
                System.out.println("Beskrivelse: "+vare.beskrivelse);
                System.out.println("P lager: "+vare.antal);
                System.out.println("Pris: "+vare.pris);
                System.out.println();
              }
            }
            break;

          case '8':
            System.out.print("Vare-ID: "); vareId=kbd.readString();
            System.out.print("KontoNr: "); kontoNr=kbd.readString();
            System.out.println(varehus.koebVare(vareId,kontoNr));
            break;

          case '9':
            System.out.print("KontoNr: "); kontoNr=kbd.readString();
            Vector ekspeditioner = varehus.visEkspeditioner(kontoNr);
            if (ekspeditioner.size()>0) {
              for (int j=0; j<ekspeditioner.size(); j++) {
                String ekspedition = (String)ekspeditioner.get(j);
                System.out.println(ekspedition);
              }
            }
            else
              System.out.println("Ingen ekspeditioner p konto: "+kontoNr);
        }
        System.out.println();
        System.out.println();
      }
      while (valg!='0');
    }
    catch(Exception e) {
      System.out.println("Kunde: " + e);
    }

    System.exit(0);
  }
}