import java.rmi.*;
import java.rmi.server.*;
import java.io.*;
import rtl.*;
import java.util.*;

public class VarehusServer {

  static BankInterface bank;
  static VarehusImpl varehus;
  static Vector varer, ekspeditioner;
  final static String VARE_LOG = "vare_log.txt";
  final static String KOEB_LOG = "koeb_log.txt";
  static TextFileRead tfr;
  static TextFileWrite tfw;
  final static String varehusNavn="RMI-Varehuset";

  public static void laesFiler() {
    ekspeditioner = new Vector();
    varer = new Vector();
    Vare vare;
    String ekspedition;
    String beskrivelse, vareId;
    int pris, antal;

    try {
       tfr = new TextFileRead(KOEB_LOG);
      do {
        ekspedition=tfr.readLine();
        if (!tfr.eof()) {
          ekspeditioner.addElement(ekspedition);
        }
      }
      while (!tfr.eof());
      tfr.close();
     }
   catch (Exception e) {
     System.out.println("VarehusServer: "+e);
   }
   try {
     tfr = new TextFileRead(VARE_LOG);
     do {
       vareId = tfr.readLine();
       if (!tfr.eof()) {
         beskrivelse = tfr.readLine();
         antal = Integer.parseInt(tfr.readLine());
         pris = Integer.parseInt(tfr.readLine());
         vare = new Vare(vareId, beskrivelse, antal, pris);
         varer.addElement(vare);
       }
     }
     while (!tfr.eof());
     tfr.close();
    }
    catch (Exception e) {
     System.out.println("VarehusServer: "+e);
    }
  }

  public static void skrivFiler() {
    try {
       tfw = new TextFileWrite(KOEB_LOG);
      for (int j=0;j<ekspeditioner.size();j++) {
        tfw.writeLine((String)ekspeditioner.get(j));
      }
      tfw.close();
    }
    catch (Exception e) {
      System.out.println("VarehusServer: "+e);
    }
    try {
      tfw = new TextFileWrite(VARE_LOG);
      for (int j=0;j<varer.size();j++) {
        tfw.writeLine(((Vare)varer.get(j)).vareId);
        tfw.writeLine(((Vare)varer.get(j)).beskrivelse);
        tfw.writeLine(""+((Vare)varer.get(j)).antal);
        tfw.writeLine(""+((Vare)varer.get(j)).pris);
      }
      tfw.close();
    }
    catch (Exception e) {
      System.out.println("VarehusServer: "+e);
    }
  }

  public static void opdaterEkspeditioner(Vector ekspeditioner) {
    VarehusServer.ekspeditioner=ekspeditioner;
  }

  public static void opdaterVarer(Vector varer) {
    VarehusServer.varer=varer;
  }

  public static void main(String[] args) {
    KbdRead kbd = new KbdRead();
    char valg;
    String vareId,beskrivelse,varehusKontoNr;
    int antal,pris;
    Vare vare;

    try {
      new FilePermission("*","read,write");
      laesFiler();

      System.out.println("Opretter linie til Bank");
      System.setSecurityManager(new RMISecurityManager());
      bank = (BankInterface)Naming.lookup("rmi://localhost/bank");

      System.out.println("Linie til Bank er oprettet");

      varehusKontoNr=bank.opretKonto("RMI-Varehuset",10000);

      varehus = new VarehusImpl(varehusNavn,varer,ekspeditioner,varehusKontoNr,bank);

      System.out.println("Binding Server implementation to Rmi registry");
      Naming.rebind("varehus",varehus);

      System.out.println("Venter p henvendelser fra Kunder");

      varehusKontoNr=bank.opretKonto("RMI-Varehuset",10000);
      System.out.println();

      do {
        System.out.println("*** "+varehusNavn+" ***");
        System.out.println("1. F kontoNummer ");
        System.out.println("2. Opret Vare ");
        System.out.println("3. Udskriv vareliste ");
        System.out.println("4. VisEkspeditioner ");
        System.out.println("5. Fjern Vare");
        System.out.println("6. Skriv til filer ");
        System.out.println("7. Afslut ");
        System.out.println();
        System.out.print("Valg: "); valg=kbd.readChar();
        switch(valg) {
          case '1':
            try {
              varehusKontoNr=bank.opretKonto(varehusNavn,10000);
              System.out.println("Varehusets kontonummer i Banken er:"+varehusKontoNr);
              break;
            }
            catch(RemoteException e) {
              System.out.println("VarehusServer "+e);
            }
          case '2':
            System.out.print("vareId: "); vareId=kbd.readString();
            System.out.print("beskrivelse: "); beskrivelse=kbd.readString();
            System.out.print("antal: "); antal=kbd.readInteger();
            System.out.print("pris: "); pris=kbd.readInteger();
            varehus.opretVare(vareId,beskrivelse,antal,pris);
            System.out.println("Varen: "+vareId+" er oprettet");
            break;
          case '3':
            for (int j=0;j<varehus.varer.size();j++) {
              System.out.println("VareId: "+((Vare)varer.get(j)).vareId);
              System.out.println("Beskrivelse: "+((Vare)varer.get(j)).beskrivelse);
              System.out.println("Antal: "+((Vare)varer.get(j)).antal);
              System.out.println("Pris: "+((Vare)varer.get(j)).pris);
            }
            break;
          case '4':
            for (int j=0;j<ekspeditioner.size();j++)
              System.out.println((String)ekspeditioner.get(j));
            break;
          case '5':
            System.out.print("vareId: "); vareId=kbd.readString();
            System.out.println(varehus.fjernVare(vareId));
            break;
          case '6':
            skrivFiler(); break;
        }
        System.out.println();
        System.out.println();
      }
      while (valg!='7');
    }
    catch(Exception e) {
      System.out.println("VarehusServer: " + e);
    }
    System.exit(0);
  }
}
