program BankKlient;
{$APPTYPE CONSOLE}
uses
  SysUtils,
  Corba,COSNaming,
  BankInterface_i,
  BankInterface_c;

const
  MaxKtoExpd=10;
type
  TKtoExpd=array[1..MaxKtoExpd] of string;

var
  bank,BankNameService:BankInterface;
  // Object that will use OSAgent for Binding
  RootContext : NamingContext;
  // Object that will use Naming Service for Binding
  nameComp : NameComponent;
  nameArray : COSNaming.Name;
  navn,kontoNr,BankNavn:string;
  saldo,beloeb,j:Integer;
  valg:Char;
  posteringer:TKtoExpd;
begin
  try
    BankNavn:='CORBA-Banken';
    CorbaInitialize;
    bank:=TBankInterfaceHelper.Bind;
    //bind to the Root Context of the NS via the orb
    RootContext:=TNamingContextHelper.
                   Narrow(Orb.ResolveInitialReferences('NameService'), True);
    //create the naming component -- match server id and kind values
    nameComp:=TNameComponent.Create('bank','');
    //set up the Name sequence
    SetLength(NameArray, 1);
    NameArray[0]:=nameComp;
    //Resolve the BankInterface object
    BankNameService:=TBankInterfaceHelper.narrow(RootContext.resolve(NameArray),
                                                 True);
    if BankNameService=nil then
    begin
      writeln('Kunne ikke lokalisere Bank objektet!'); readln
    end else
    begin
      writeln;
      writeln('******* '+BankNavn+' *******');
      writeln;
      repeat
        writeln;
        writeln('1. Opret Konto ');
        writeln('2. Indst p konto ');
        writeln('3. Hv fra konto ');
        writeln('4. Vis Saldo ');
        writeln('5. Vis posteringer p konto ');
        writeln('6. Afslut ');
        writeln;
        write('Valg: '); readln(valg);
        case valg of
          '1':
          begin
            write('Navn: '); readln(navn);
            write('Saldo: '); readln(saldo);
            writeln(bank.opretKonto(navn,saldo));
          end;
          '2':
          begin
            write('KontoNr: '); readln(kontoNr);
            write('belb: '); readln(beloeb);
            if (bank.indsaetBeloeb(kontoNr, beloeb)) then
              writeln('Belbet '+IntToStr(beloeb)+' kr. er indsat p kontoNr '+kontoNr)
            else
              writeln('Belbet kunne ikke indsttes p kontoNr: '+kontoNr)
          end;
          '3':
          begin
            write('KontoNr: '); readln(kontoNr);
            write('belb: '); readln(beloeb);
            if (bank.haevBeloeb(kontoNr, beloeb)) then
              writeln('Belbet '+IntToStr(beloeb)+' kr. er hvet p konto: '+kontoNr)
            else writeln('Belbet kunne ikke hves p konto: '+kontoNr,#10#13,
                         'Se kvitteringen for detaljer')
          end;
          '4':
          begin
            write('KontoNr: '); readln(kontoNr);
            writeln(bank.visSaldo(kontoNr))
          end;
          '5':
          begin
            write('KontoNr: '); readln(kontoNr);
            posteringer:=TktoExpd(bank.visEkspeditioner(kontoNr));
            if posteringer[1]<>'' then
            begin
              j:=0;
              while posteringer[j+1]<>'' do
              begin
                inc(j); writeln(posteringer[j]);
              end
            end else writeln('Ingen posteringer p konto: '+kontoNr);
          end;
        end;
      until valg='6'
    end
  except
    on E:Exception do writeln('BankKlient: ',E.Message)
  end
end.

