import rtl.*;
import java.util.*;
import org.omg.CORBA.*;
import org.omg.CosNaming.*;
import org.omg.CosNaming.NamingContextPackage.*;
import org.omg.PortableServer.*;
import org.omg.PortableServer.POA;
import org.omg.PortableServer.POAPackage.*;


public class BankServer {

  public static void main(String[] args) {
    KbdRead kbd = new KbdRead();
    try {
      System.out.println("create and initialize the ORB.");

      ORB orb = ORB.init(args, null);

      System.out.println(" get reference to rootPOA and the POAManager");

      POA rootPOA = (POA)orb.resolve_initial_references("RootPOA");
      POAManager poaManager = rootPOA.the_POAManager();

      System.out.println("make new (default) policy");

      Policy[] serverPolicy = new Policy[0];
      POA serverPOA = rootPOA.create_POA("default",poaManager,serverPolicy);

      System.out.println(" create Bank server");

      BankServerImpl bankServerImpl = new BankServerImpl("CORBA-Banken");

      System.out.println(" activate Bank server");

      serverPOA.activate_object(bankServerImpl);

      System.out.println(" get object reference from the server");

      org.omg.CORBA.Object bankServerRef = serverPOA.servant_to_reference(bankServerImpl);
      BankInterface bank = BankInterfaceHelper.narrow(bankServerRef);


      System.out.println(" get the root naming context");
      System.out.println(" NameService invokes the transient name service");

      org.omg.CORBA.Object objRef = orb.resolve_initial_references("NameService");

      System.out.println(" Use NamingContextExt which is part of the Interoperable");
      System.out.println(" Naming Service (INS) specification.");

      NamingContextExt namingContextExt = NamingContextExtHelper.narrow(objRef);

      System.out.println(" bind the Object Reference in Naming");

      NameComponent path[] = namingContextExt.to_name("bank");
      namingContextExt.rebind(path, bank);

      System.out.println("Server ready and waiting ...");

      System.out.println(" wait for invocations from clients");

      poaManager.activate();
      //orb.run();
      System.out.println();
      System.out.println();
      System.out.println("********* CORBA-Banken **********");
      System.out.println();
      char valg;
      do {
        System.out.println();
        System.out.println("1. Vis alle konti ");
        System.out.println("2. Vis alle ekspeditioner");
        System.out.println("3. Find kunde navn ");
        System.out.println("4. Vis sidste ekspedition");
        System.out.println("5. Registrer posteringer ");
        System.out.println("6. Vis Ribers kunder ");
        System.out.println("7. Afslut ");
        System.out.println();
        System.out.print("Valg: "); valg=kbd.readChar();
        switch(valg) {
          case '1':
            BankServerImpl.visAlleKonti();
            break;
          case '2':
            BankServerImpl.visAlleEkspeditioner();
            break;
          case '3':
            System.out.print("KontoNr: "); String kontoNr=kbd.readString();
            BankServerImpl.visKundeNavn(kontoNr);
            break;
          case '4':
            BankServerImpl.visSidsteEkspedition();
              break;
          case '5':
            if (BankServerImpl.registrerTransaktioner())
              System.out.println("Alle posteringer er registreret i fil");
            else
              System.out.println("Posteringer kunne ikke registreres i fil");
              break;
          case '6':
            BankServerImpl.visRibersKunder();
            break;
          case '7':
            orb.shutdown(false);
        }
      }
      while(valg!='7');
    }
    catch (Exception e) {
      System.err.println("BankServer: "+e);
      e.printStackTrace(System.out);
    }
  }
}

