import rtl.*;
import java.util.*;
import org.omg.CORBA.*;
import org.omg.CosNaming.*;
import org.omg.CosNaming.NamingContextPackage.*;
import org.omg.PortableServer.*;
import org.omg.PortableServer.POA;
import org.omg.PortableServer.POAPackage.*;


public class BankServerImpl extends BankInterfacePOA {

  private static String bank;
  private static String ekspedition,ribersKunde;
  static TextFileRead tfr;
  static TextFileWrite tfw;
  private static Vector konti, ekspeditioner, ribersKunder;

  Date dato;
  static final String KONTI_LOG = "konti.txt";
  static final String EXPD_LOG = "expd_log.txt";
  static final String RIBERS_LOG = "ribers.txt";

  public BankServerImpl(String bank){

    this.bank=bank;
    ekspeditioner = new Vector();

    try {
      tfr = new TextFileRead(EXPD_LOG);
      do {
        ekspedition=tfr.readLine();
        if (!tfr.eof()) {
          ekspeditioner.addElement(ekspedition);
        }
      }
      while (!tfr.eof());
      tfr.close();
    }
    catch (NullPointerException e) {
      System.out.println(e);
    }

    konti = new Vector();
    int antalKonti=-1;
    String navn, kontoNr;
    int saldo;

    try {
      tfr = new TextFileRead(KONTI_LOG);
      do {
        navn = tfr.readLine();
        if (!tfr.eof()) {
          antalKonti++;
          kontoNr = tfr.readLine();
          saldo = Integer.parseInt(tfr.readLine());
          Konto konto = new Konto(navn, kontoNr, saldo);
          konti.addElement(konto);
        }
      }
      while (!tfr.eof());
      tfr.close();
    }
    catch (NullPointerException e) {
      System.out.println("BankServerImpl: "+e);
    }
    ribersKunder = new Vector();

    try {
      tfr = new TextFileRead(RIBERS_LOG);
      do {
        ribersKunde=tfr.readLine();
        if (!tfr.eof()) {
          ribersKunder.addElement(ribersKunde);
        }
      }
      while (!tfr.eof());
      tfr.close();
    }
    catch (NullPointerException e) {
      System.out.println(e);
    }
  }

  public String opretKonto(String navn, int saldo){
    String kontoNr;
    int kto;
    if (ribersKunder.size()>0) {
      int j=0;
      while (j<ribersKunder.size() && ((String)ribersKunder.get(j)).indexOf(navn)<0) j++;
      if (j<ribersKunder.size())
        return "Der kan ikke oprettes en konto p navnet: "+navn+" da de er opfoert som daarlig betaler";
    }
    kto = (int) Math.round(Math.random()*100000000);
    kontoNr = ""+kto;
    konti.addElement(new Konto(navn,kontoNr,saldo));
    return "Der er oprettet en konto p navnet: "+navn+" med kontoNr."+kontoNr;
  }

  public String visSaldo(String kontoNr){

    for (int k=0; k<konti.size(); k++) {
      if (kontoNr.equals(((Konto)konti.get(k)).kontoNr))
        return "Saldoen paa kontoen "+kontoNr+" er "+((Konto)konti.get(k)).saldo;
    }
      return "Konto Nr "+kontoNr+" findes ikke";
  }

  public boolean indsaetBeloeb(String kontoNr, int beloeb){

    for (int k=0; k<konti.size(); k++) {
      if (kontoNr.equals(((Konto)konti.get(k)).kontoNr)) {
    int saldo = ((Konto)konti.get(k)).saldo+beloeb;
        ((Konto)konti.get(k)).saldo = saldo;
        dato = new Date();
        String ekspedition = bank+": "+dato.toString()+": Indsat "+beloeb+
                             " kr. paa konto:"+kontoNr+". Saldo kr. "+saldo;
        ekspeditioner.addElement(ekspedition);
        return true;
      }
    }
    return false;
  }

  public boolean haevBeloeb(String kontoNr, int beloeb){

    String ekspedition;
    dato = new Date();
    if (konti.size()>0) {
      int k=0;
      while(k<konti.size() && !kontoNr.equals(((Konto)konti.get(k)).kontoNr)) k++;
      if (k<konti.size()) {
        if ((beloeb>0) && (((Konto)konti.get(k)).saldo>=beloeb)) {
          int saldo = ((Konto)konti.get(k)).saldo-beloeb;
          ((Konto)konti.get(k)).saldo = saldo;
          ekspedition = bank+": "+dato.toString()+": Haevet "+beloeb+
                               " kr. paa konto:"+kontoNr+". Saldo kr. "+saldo;
          ekspeditioner.addElement(ekspedition);
          return true;
        }
        else {
          ekspedition= bank+": "+dato.toString()+": "+((Konto)konti.get(k)).navn;
          ribersKunder.addElement(ekspedition);
          ekspedition = bank+": "+dato.toString()+" Kontoen "+kontoNr+
                        " er lukket p grund af overtrk."+
                        "De er anbragt i Ribers kartotek. Saldo udbetales kr. "+
                        ((Konto)konti.get(k)).saldo;
          ((Konto)konti.get(k)).saldo = 0;
          ekspeditioner.addElement(ekspedition);
          return false;
        }
      }
      else {
        ekspedition = bank+": "+dato.toString()+" KontoNr: "+kontoNr+" Findes ikke";
        ekspeditioner.addElement(ekspedition);
        return false;
      }
    }
    else return false;
  }

  public String[] visEkspeditioner(String kontoNr){

    String[] ktoExpd = {"","","","","","","","","",""};
    int expdNr=-1;
    for (int k=ekspeditioner.size()-1; k>=0; k--) {
      String exp =(String)ekspeditioner.get(k);
      if (exp.indexOf(kontoNr)>0) ktoExpd[++expdNr]=exp;
      if (expdNr==9) return ktoExpd;
    }
    return ktoExpd;
  }

  public static boolean registrerTransaktioner() {
    try {
       tfw = new TextFileWrite(EXPD_LOG);
      for (int j=0;j<ekspeditioner.size();j++) {
        tfw.writeLine((String)ekspeditioner.get(j));
      }
      tfw.close();
    }
    catch (NullPointerException e) {
      System.out.println(e);
      return false;
    }
    try {
      tfw = new TextFileWrite(KONTI_LOG);
      for (int j=0;j<konti.size();j++) {
        tfw.writeLine(((Konto)konti.get(j)).navn);
        tfw.writeLine(((Konto)konti.get(j)).kontoNr);
        tfw.writeLine(""+((Konto)konti.get(j)).saldo);
      }
      tfw.close();
    }
    catch (NullPointerException e) {
      System.out.println(e);
      return false;
    }
    try {
       tfw = new TextFileWrite(RIBERS_LOG);
      for (int j=0;j<ribersKunder.size();j++) {
        tfw.writeLine((String)ribersKunder.get(j));
      }
      tfw.close();
      return true;
    }
    catch (NullPointerException e) {
      System.out.println(e);
      return false;
    }
  }

  static void visAlleKonti() {
    System.out.println("Liste over de "+konti.size()+" kontohavere i "+bank);
    for (int j=0;j<konti.size();j++) {
      System.out.println("Navn: "+((Konto)konti.get(j)).navn);
      System.out.println("KontoNr: "+((Konto)konti.get(j)).kontoNr);
      System.out.println("Saldo: "+((Konto)konti.get(j)).saldo);
    }
  }
  static void visAlleEkspeditioner() {
    System.out.println("Liste over de "+ekspeditioner.size()+" ekspeditioner i "+bank);
    for (int j=0;j<ekspeditioner.size();j++)
      System.out.println(ekspeditioner.get(j));
  }
  static void visSidsteEkspedition() {
    if (ekspeditioner.size()>0)
      System.out.println(ekspeditioner.get(ekspeditioner.size()-1));
  }
  static void visKundeNavn(String kontoNr) {
    if (konti.size()>0) {
      int j=0;
      while (j<konti.size() && !kontoNr.equals(((Konto)konti.get(j)).kontoNr)) j++;
      if (j<konti.size())
        System.out.println("Navnet paa kontohaveren med kontoNr: "+kontoNr+" er: "+((Konto)konti.get(j)).navn);
      else
        System.out.println("Ingen kontohavere med kontoNr: "+kontoNr);
    }
  }
  static void visRibersKunder() {
    System.out.println("Liste over de "+ribersKunder.size()+" ribersKunder i "+bank);
    for (int j=0;j<ribersKunder.size();j++)
      System.out.println(ribersKunder.get(j));
  }

}


