import rtl.*;

public class EightQueensAllSolutions {

  static boolean onBoard(byte x) {
    return (x>0) && (x<9);
  }

  static boolean[] freeRow(byte row, boolean[] queen, byte[] queens) {
    byte x,y;
    boolean[] free = new boolean[9];
    for (x=1; x<=8; x++) free[x]=true;
    for (y=1; y<=8; y++) {
      if (queen[y]) {
        free[queens[y]]=false;
        x=(byte)(row-y+queens[y]);
        if (onBoard(x)) free[x]=false;
        x=(byte)(y-row+queens[y]);
        if (onBoard(x)) free[x]=false;
      }
    }
    return free;
  }

  static void writeAllowedFields(boolean[][] chessBoard, byte[] queens, boolean[] queensInitial) {
    byte x,y;
    char ch;
    String hvidtFelt=""+(char)219+""+(char)219;
    String sortFelt=""+(char)178+""+(char)178;
    for (y=8; y>=1; y--) {
      System.out.print(""+y+" ");
      for (x=1; x<=8; x++) {
        if (queensInitial[y] && (queens[y]==x)) System.out.print("D"+y);
        else {
          if (!chessBoard[x][y]) System.out.print("--");
          else {
            if ((x+y) % 2==0) System.out.print(sortFelt);
              else System.out.print(hvidtFelt);
          }
        }
      }
      System.out.println();
    }
    System.out.println();
    System.out.print("  ");
    for (x=1; x<=8; x++)
    System.out.print(""+(char)((int)('A')+(int)x -1)+" ");
    System.out.println();
  }

  public static void main(String[] args) {
    KbdRead kbd = new KbdRead();
    String dx="";
    char ch;
    boolean ok=true;
    byte[] queens = new byte[9];
    boolean[] queensInitial = new boolean[9];
    boolean[] queen = new boolean[9];
    byte[] q1 = {1,1,1,1,1,1,1,1,1};
    byte[] q8 = {8,8,8,8,8,8,8,8,8};
    boolean[][] chessBoard = new boolean[9][9];
    byte x,y;
    boolean[][] freeField = new boolean[9][9];
    for (y=1; y<=8; y++) {
      queen[y]=false;
      queensInitial[y]=false;
      for (x=1; x<=8; x++) chessBoard[x][y]=true;
    }
    writeAllowedFields(chessBoard,queens,queensInitial);
    for (byte q=1;q<=8;q++) {
      ok=true;
      do {
        x=1; y=1;
        System.out.println();
        if (!ok) System.out.println("Der kan ikke placeres en dronning p "+dx);
        System.out.print("Angiv placeringen af den "+q+". dronning. (f.eks. D6) ");
        dx=kbd.readString();
        System.out.println();
        ok=dx.length()==2;
        if (ok) {
          x=(byte)((int)(dx.charAt(0))-(int)('A')+1);
          y=(byte)((int)(dx.charAt(1)) -(int)('0'));
          ok=onBoard(x) && onBoard(y) && chessBoard[x][y];
        }
      }
      while(!ok);
      queens[y]=x; queensInitial[y]=true; queen[y]=true;
      q1[y]=queens[y]; q8[y]=queens[y];
      for (y=1; y<=8; y++)
      for (x=1; x<=8; x++) chessBoard[y][x]=false;
      for (y=1; y<=8; y++)
      for (x=1; x<=8; x++) freeField[y][x]=true;
      for  (y=1; y<=8; y++)
        if (!queensInitial[y]) queen[y]=false;
      if (!queensInitial[1]) freeField[1]=freeRow((byte)1,queen,queens);
      for (byte x1=q1[1]; x1<=q8[1]; x1++) {
        if (!queensInitial[1]) {
          ok=freeField[1][x1];
          if(ok) {
            queens[1]=x1; queen[1]=true;
          }
        }
        if (queensInitial[1] || ok) {
          for  (y=2; y<=8; y++)
            if (!queensInitial[y]) queen[y]=false;
          if (!queensInitial[2]) freeField[2]=freeRow((byte)2,queen,queens);
          for (byte x2=q1[2]; x2<=q8[2]; x2++) {
            if (!queensInitial[2]) {
              ok=freeField[2][x2];
              if(ok) {
                queens[2]=x2; queen[2]=true;
              }
            }
            if (queensInitial[2] || ok) {
              for  (y=3; y<=8; y++)
                if (!queensInitial[y]) queen[y]=false;
              if (!queensInitial[3]) freeField[3]=freeRow((byte)3,queen,queens);
              for (byte x3=q1[3]; x3<=q8[3]; x3++) {
                if (!queensInitial[3]) {
                  ok=freeField[3][x3];
                  if(ok) {
                    queens[3]=x3; queen[3]=true;
                  }
                }
                if (queensInitial[3] || ok) {
                  for  (y=4; y<=8; y++)
                    if (!queensInitial[y]) queen[y]=false;
                  if (!queensInitial[4]) freeField[4]=freeRow((byte)4,queen,queens);
                  for (byte x4=q1[4]; x4<=q8[4]; x4++) {
                    if (!queensInitial[4]) {
                      ok=freeField[4][x4];
                      if(ok) {
                        queens[4]=x4; queen[4]=true;
                      }
                    }
                    if (queensInitial[4] || ok) {
                      for  (y=5; y<=8; y++)
                        if (!queensInitial[y]) queen[y]=false;
                      if (!queensInitial[5]) freeField[5]=freeRow((byte)5,queen,queens);
                      for (byte x5=q1[5]; x5<=q8[5]; x5++) {
                        if (!queensInitial[5]) {
                          ok=freeField[5][x5];
                          if(ok) {
                            queens[5]=x5; queen[5]=true;
                          }
                        }
                        if (queensInitial[5] || ok) {
                          for  (y=6; y<=8; y++)
                            if (!queensInitial[y]) queen[y]=false;
                          if (!queensInitial[6]) freeField[6]=freeRow((byte)6,queen,queens);
                          for (byte x6=q1[6]; x6<=q8[6]; x6++) {
                            if (!queensInitial[6]) {
                              ok=freeField[6][x6];
                              if(ok) {
                                queens[6]=x6; queen[6]=true;
                              }
                            }
                            if (queensInitial[6] || ok) {
                              for  (y=7; y<=8; y++)
                                if (!queensInitial[y]) queen[y]=false;
                              if (!queensInitial[7]) freeField[7]=freeRow((byte)7,queen,queens);
                              for (byte x7=q1[7]; x7<=q8[7]; x7++) {
                                if (!queensInitial[7]) {
                                  ok=freeField[7][x7];
                                  if(ok) {
                                    queens[7]=x7; queen[7]=true;
                                  }
                                }
                                if (queensInitial[7] || ok) {
                                  for  (y=8; y<=8; y++)
                                    if (!queensInitial[y]) queen[y]=false;
                                  if (!queensInitial[8]) freeField[8]=freeRow((byte)8,queen,queens);
                                  for (byte x8=q1[8]; x8<=q8[8]; x8++) {
                                    if (!queensInitial[8]) {
                                      ok=freeField[8][x8];
                                      if(ok) {
                                        queens[8]=x8; queen[8]=true;
                                      }
                                    }
                                    if (queensInitial[8] || ok) {
                                      for (byte k=1;k<9;k++)
                                      if (!queensInitial[k]) chessBoard[queens[k]][k]=true;
                                    }
                                  }
                                }
                              }
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        }
      }
      if (q==8)
        for (y=1; y<=8; y++)
          for (x=1; x<=8; x++) chessBoard[x][y]=true;
      writeAllowedFields(chessBoard,queens,queensInitial);
    }
  }
}

