import java.util.*;
import rtl.*;

public class MetodeDemo {
  static final int MAXORD=10001;

  static String[] lavOrdliste(int n) {
    String[] ordliste = new String[MAXORD];
    for (int i=1; i<=n; i++) {
      ordliste[i]="";
      int nb= (int)(Math.random()*10+1);
      for (int k=1; k<=nb; k++) {
        ordliste[i]=ordliste[i]+(char)((int)('a')+(int)(Math.random()*26));
      }
    }
    return ordliste;
  }

  static void udskrivOrdliste(String[] ordliste, int n) {
    String blank ="           ";
    for (int j=1; j<=n; j++) {
      String ord = ordliste[j]+blank.substring(0,10-ordliste[j].length());
      if (j<10) System.out.print("Ord("+j+")="+ord+"   ");
      else
        if (j<100) System.out.print("Ord("+j+")="+ord+"  ");
          else
            if (j<1000) System.out.print("Ord("+j+")="+ord+" ");
              else
                System.out.print("Ord("+j+")="+ord);
      if (j%4==0) System.out.println();
    }
  }

  static int maxOrd(String[] ordliste, int n) {
    String max = "";
    int maxNo=0;
    for (int i=1; i<=n; i++) {
      if (ordliste[i].compareTo(max)>0) {
        max=ordliste[i];
        maxNo=i;
      }
    }
    return maxNo;
  }

  static String[] selectionSort(String[] ordliste, int n) {
    int max;
    for (int i=n; i>=1; i--) {
      max=maxOrd(ordliste,i);
      String ord=ordliste[max];
      ordliste[max]=ordliste[i];
      ordliste[i]=ord;
    }
    return ordliste;
  }

  static String[] quickSort(int venstre, int hoejre, String[] ordliste) {
    int i = venstre; int j = hoejre;
    String midtOrd = ordliste[(venstre+hoejre)/2];
    do {
      while(midtOrd.compareTo(ordliste[i])>0) i++;
      while(midtOrd.compareTo(ordliste[j])<0) j--;
      if (i<=j) {
        String ord = ordliste[i]; ordliste[i] = ordliste[j]; ordliste[j] = ord;
        i++; j--;
      }
    }
    while (i<=j);
    if (venstre<j) ordliste = quickSort(venstre,j,ordliste);
    if (i<hoejre) ordliste = quickSort(i,hoejre,ordliste);
    return ordliste;
  }

  static int binaerSoegning(String soegeOrd, String[] ordliste, int n) {
    int plads=0,midt=0,hoejre=n,venstre=1;
    do {
      midt = (hoejre+venstre)/2;
      if (soegeOrd.equals(ordliste[midt])) return midt;
      if (soegeOrd.compareTo(ordliste[midt])>0) venstre=midt+1;
      else hoejre=midt-1;
    }
    while (venstre<=hoejre);
    return 0;
  }

  public static void main (String args[]) {
    KbdRead kbd = new KbdRead();
    String[] ordliste = new String[MAXORD];
    System.out.println("Nu laver vi frst en ordlistetabel");
    System.out.print("Indls antallet af ord, der skal dannes ");
    int antal=kbd.readInteger();
    long startTid = new Date().getTime();
    ordliste=lavOrdliste(antal);
    long slutTid = new Date().getTime();
    long msek = (slutTid-startTid);
    System.out.println();
    System.out.println("Det tog "+msek+" ms at lave "+antal+" ord i ordlisten");
    System.out.println();
    System.out.println("Nu vil vi finde det strste ord i ordlisten efter leksikalsk ordning");
    int max =maxOrd(ordliste,antal);
    System.out.println();
    System.out.println("Det strste ord er "+ordliste[max]+". som str p plads nr. "+max);
    System.out.println();
    System.out.print("Vil du have den usorterede ordliste udskrevet? j/n ");
    char ch=kbd.readChar();
    if (ch=='j') udskrivOrdliste(ordliste,antal);
    System.out.println();
    System.out.print("Sortering af ordlisten med Q)uickSort, S)electionSort? ");
    ch=kbd.readChar();
    startTid = new Date().getTime();
    if (ch=='s') ordliste=selectionSort(ordliste,antal);
    else ordliste=quickSort(1, antal,ordliste);
    slutTid = new Date().getTime();
    msek = (slutTid-startTid);
    System.out.println();
    System.out.print("Det tog "+msek+" ms, at sortere ordlisten ");
    if (ch=='s') System.out.println("med SelectionSort");
    else System.out.println("med QuickSort");
    System.out.println();
    System.out.print("Vil du have den sorterede ordliste udskrevet? j/n ");
    ch=kbd.readChar();
    if (ch=='j') udskrivOrdliste(ordliste,antal);
    boolean slut;
    do {
      System.out.println();
      System.out.print("Skriv et ord, s findes det i ordlisten (Enter=Afslut) ");
      String soegeOrd=kbd.readString();
      slut=soegeOrd.equals("");
      int no=binaerSoegning(soegeOrd, ordliste, antal);
      System.out.println();
      if (!slut) {
        if (no>0) System.out.println("Sgeordet "+soegeOrd+" str p plads "+no+" i listen");
        else System.out.println("Sgeordet "+soegeOrd+" str ikke i listen");
     }
    }
    while (! slut);
    System.exit(0);
  }
}